#include <stdio.h>
#include <SDL/SDL.h>

#ifdef __EMSCRIPTEN__
#include <emscripten.h>
#endif

extern "C" int main(int argc, char** argv) {
	printf("hello, world!\n");

	SDL_Init(SDL_INIT_VIDEO);
	int sw=256, sh=256;
	SDL_Surface *screen = SDL_SetVideoMode(sw, sh, 32, SDL_SWSURFACE);

#ifdef TEST_SDL_LOCK_OPTS
	EM_ASM("SDL.defaults.copyOnLock = false; SDL.defaults.discardOnLock = true; SDL.defaults.opaqueFrontBuffer = false;");
#endif

	if (SDL_MUSTLOCK(screen)) SDL_LockSurface(screen);
	for (int i = 0; i < sh; i++) {
		for (int j = 0; j < sw; j++) {
#ifdef TEST_SDL_LOCK_OPTS
			// Alpha behaves like in the browser, so write proper opaque pixels.
			int alpha = 255;
#else
			// To emulate native behavior with blitting to screen, alpha component is ignored. Test that it is so by outputting
			// data (and testing that it does get discarded)
			int alpha = (i+j) % 255;
#endif
			if(i<=255 && j<=255){
				*((Uint32*)screen->pixels + i * sw + j) = SDL_MapRGBA(screen->format, i, j, 255-i, alpha);
			}
		}
	}
	if (SDL_MUSTLOCK(screen)) SDL_UnlockSurface(screen);
	SDL_Flip(screen); 

	printf("bits per pixel: %d, bytes per pixel: %d\n", screen->format->BitsPerPixel, screen->format->BytesPerPixel);
	printf("you should see a smoothly-colored square - no sharp lines but the square borders!\n");
	printf("and here is some text that should be HTML-friendly: amp: |&| double-quote: |\"| quote: |'| less-than, greater-than, html-like tags: |<cheez></cheez>|\nanother line.\n");

	SDL_Quit();

	return 0;
}
